import { HTTPProvider } from '@zilliqa-js/core';
import { TransactionFactory, Wallet } from '@zilliqa-js/account';
import { Contracts } from '@zilliqa-js/contract';
import { Blockchain, Network } from '@zilliqa-js/blockchain';
import { SubscriptionBuilder } from '@zilliqa-js/subscriptions';
export * from '@zilliqa-js/subscriptions';
export * from '@zilliqa-js/util';
export * from '@zilliqa-js/crypto';

//  Copyright (C) 2018 Zilliqa
var Zilliqa = /** @class */ (function () {
    function Zilliqa(node, provider) {
        this.provider = provider || new HTTPProvider(node);
        this.wallet = new Wallet(this.provider);
        this.blockchain = new Blockchain(this.provider, this.wallet);
        this.network = new Network(this.provider, this.wallet);
        this.contracts = new Contracts(this.provider, this.wallet);
        this.transactions = new TransactionFactory(this.provider, this.wallet);
        this.subscriptionBuilder = new SubscriptionBuilder();
    }
    return Zilliqa;
}());

export { Zilliqa };
//# sourceMappingURL=index.esm.js.map
