"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBalance = exports.sendZIL = exports.getMinGasPrice = exports.createAccount = exports.MAGENTA = void 0;
var zilliqa_1 = require("@zilliqa-js/zilliqa");
var signable_1 = require("./signable");
exports.MAGENTA = "\x1B[35m%s\x1b[0m";
/**
 * create an account using Zilliqa
 */
function createAccount() {
    var zil = new zilliqa_1.Zilliqa("");
    var addr = zil.wallet.create();
    var account = zil.wallet.accounts[addr];
    var address = new signable_1.ByStr20(addr);
    var pubkey = new signable_1.ByStr33(account.publicKey);
    return { account: account, address: address, pubkey: pubkey };
}
exports.createAccount = createAccount;
/**
 * get min gas price return already as BN
 */
function getMinGasPrice(zil) {
    return __awaiter(this, void 0, void 0, function () {
        var res;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, zil.blockchain.getMinimumGasPrice()];
                case 1:
                    res = _a.sent();
                    if (!res.result) {
                        throw "no gas price";
                    }
                    return [2 /*return*/, { gasPrice: new zilliqa_1.BN(res.result) }];
            }
        });
    });
}
exports.getMinGasPrice = getMinGasPrice;
/**
 * Send zil to an account convinience method
 *
 * @param resolvers the sdk resolvers
 * @param to address to send the zil to
 * @param amt of zil to send
 * @returns the transaction if successful
 */
function sendZIL(resolvers, to, amt) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, zil, teardown, gasLimit, gasPrice, tx, _b, _c, e_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, resolvers.getZil(true)];
                case 1:
                    _a = _d.sent(), zil = _a.zil, teardown = _a.teardown;
                    gasLimit = zilliqa_1.Long.fromString("20000");
                    return [4 /*yield*/, getMinGasPrice(zil)];
                case 2:
                    gasPrice = (_d.sent()).gasPrice;
                    _d.label = 3;
                case 3:
                    _d.trys.push([3, 6, , 8]);
                    _c = (_b = zil.blockchain).createTransaction;
                    return [4 /*yield*/, zil.transactions.payment({
                            gasLimit: gasLimit,
                            gasPrice: gasPrice,
                            toAddr: to.toSend(),
                            amount: new zilliqa_1.BN(amt.toSend()),
                            version: resolvers.getVersion(),
                        })];
                case 4: return [4 /*yield*/, _c.apply(_b, [_d.sent(), 31,
                        1000])];
                case 5:
                    tx = _d.sent();
                    console.log(exports.MAGENTA, "\uD83E\uDD11 Sent ZIL " + to.toSend());
                    return [2 /*return*/, tx];
                case 6:
                    e_1 = _d.sent();
                    return [4 /*yield*/, teardown()];
                case 7:
                    _d.sent();
                    throw e_1;
                case 8: return [2 /*return*/];
            }
        });
    });
}
exports.sendZIL = sendZIL;
function getBalance(getZil, a) {
    return __awaiter(this, void 0, void 0, function () {
        var res, bal;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getZil()];
                case 1:
                    res = _a.sent();
                    return [4 /*yield*/, res.zil.blockchain.getBalance(a.toSend())];
                case 2:
                    bal = _a.sent();
                    return [4 /*yield*/, res.teardown()];
                case 3:
                    _a.sent();
                    return [2 /*return*/, new signable_1.Uint128(bal.result.balance)];
            }
        });
    });
}
exports.getBalance = getBalance;
//# sourceMappingURL=account.js.map