export declare function removeComments(lexed: string[]): any[];
export declare function justBody(lexed: string[]): string[];
export declare function getInfo(lexed: string[]): {
    contractName: string;
};
export interface Param {
    vname: string;
    type: string;
    lexed: string[];
}
export interface Method {
    name: string;
    params: Param[];
    nonKeyWords: string[];
    accepts?: true;
}
export declare type Transition = Method;
export declare type Procedure = Transition;
export interface CustomType {
    name: string;
    lexed: string[];
    constructors: {
        [name: string]: {
            lexed: string[];
            name: string;
        };
    };
}
export declare function justTypes(lexed: string[]): {
    [t: string]: CustomType;
};
export declare function justTransitions(lexed: string[]): Transition[];
