"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.justTransitions = exports.justTypes = exports.getInfo = exports.justBody = exports.removeComments = void 0;
var constants_1 = require("./constants");
function removeComments(lexed) {
    var start = "(*";
    var end = "*)";
    var isComment = false;
    var res = [];
    for (var x = 0; x < lexed.length; x++) {
        var token = lexed[x];
        if (isComment) {
            if (token == end) {
                isComment = false;
            }
            continue;
        }
        if (token == start) {
            isComment = true;
            continue;
        }
        res.push(token);
    }
    return res;
}
exports.removeComments = removeComments;
function justBody(lexed) {
    var x = lexed.indexOf("contract");
    return lexed.slice(x + 1);
}
exports.justBody = justBody;
function getInfo(lexed) {
    return { contractName: lexed[lexed.indexOf("contract") + 1] };
}
exports.getInfo = getInfo;
var processMethod = function (lexed) {
    //first is keyword next is the name
    var res = { name: lexed[1], params: [], nonKeyWords: [] };
    // open -> vname : type maybe(,) -> jump back to vname
    // start after (
    var x = 2;
    while (lexed[x] != ")") {
        x++;
        if (lexed[x + 1] == ":") {
            var param = { vname: lexed[x], type: "", lexed: [] };
            //next until , or ) is the type
            var typeStart = x + 2;
            while (lexed[x] != "," && lexed[x] != ")") {
                x++;
            }
            param.lexed = lexed.slice(typeStart, x);
            param.type = param.lexed.join(" ");
            res.params.push(param);
        }
    }
    // body after signature
    var i = x;
    while (i < lexed.length) {
        if (lexed[i] == "accept")
            res.accepts = true;
        if (!constants_1.allWords.includes(lexed[i]))
            res.nonKeyWords.push(lexed[i]);
        i++;
    }
    return res;
};
var justMethods = function (keyword) {
    return function (methodProcessor) {
        return function (lexed) {
            var res = {};
            var x = 0;
            while (x < lexed.length) {
                if (lexed[x] == keyword) {
                    var start = x;
                    x++;
                    while (lexed[x] != "transition" &&
                        lexed[x] != "procedure" &&
                        x < lexed.length) {
                        x++;
                    }
                    var p = methodProcessor(lexed.slice(start, x));
                    res[p.name] = p;
                    continue;
                }
                x++;
            }
            return res;
        };
    };
};
function justTypes(lexed) {
    var types = {};
    var x = 0;
    var _loop_1 = function () {
        if (lexed[x] == "type") {
            var start = x;
            var last = x + 3;
            x++;
            var t_1 = {
                name: lexed[x],
                constructors: {},
                lexed: [],
            };
            while (lexed[x] != "let" &&
                lexed[x] != "contract" &&
                lexed[x] != "type") {
                if (lexed[x] == "|" && last < x) {
                    var name_1 = lexed[last + 1];
                    t_1.constructors[name_1] = {
                        lexed: lexed.slice(last + 1, x),
                        name: name_1,
                    };
                    last = x;
                }
                x++;
            }
            var name = lexed[last + 1];
            t_1.constructors[name] = {
                lexed: lexed.slice(last + 1, x),
                name: name,
            };
            t_1.lexed = lexed.slice(start, x);
            Object.entries(t_1.constructors).forEach(function (_a) {
                var name = _a[0], c = _a[1];
                return (types[name] = t_1);
            });
        }
        x++;
    };
    while (x < lexed.length) {
        _loop_1();
    }
    return types;
}
exports.justTypes = justTypes;
function justTransitions(lexed) {
    var procedures = justMethods("procedure")(processMethod)(lexed);
    var procs = Object.keys(procedures);
    // reference procedure calls
    Object.entries(procedures).forEach(function (_a) {
        var k = _a[0], v = _a[1];
        return (v.nonKeyWords = v.nonKeyWords
            .map(function (i) { return i.split(" ")[0]; })
            .filter(function (i) { return procs.includes(i); }));
    });
    function findIfAccepts(m) {
        if (m.accepts) {
            return true;
        }
        return m.nonKeyWords
            .map(function (i) { return findIfAccepts(procedures[i]); })
            .some(function (v) { return v == true; });
    }
    // resolve if procedures accept
    Object.entries(procedures).forEach(function (_a) {
        var k = _a[0], v = _a[1];
        var acc = findIfAccepts(v);
        if (acc) {
            v.accepts = true;
        }
    });
    var transitions = justMethods("transition")(function (l) {
        var t = processMethod(l);
        t.nonKeyWords = t.nonKeyWords
            .map(function (i) { return i.split(" ")[0].trim(); })
            .filter(function (i) { return procs.includes(i); });
        var accepts = t.nonKeyWords.reduce(function (prev, cur) { return (prev ? true : procedures[cur].accepts == true); }, false);
        if (accepts) {
            t.accepts = accepts;
        }
        return t;
    })(lexed);
    return Object.entries(transitions).map(function (_a) {
        var k = _a[0], v = _a[1];
        return v;
    });
}
exports.justTransitions = justTransitions;
//# sourceMappingURL=parser.js.map