"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lexScilla = void 0;
var constants_1 = require("./constants");
var lex_1 = require("./lex");
var parser_1 = require("./parser");
var escSpace = function (r) { return ({
    regex: new RegExp("\\s+" + r + "\\s+"),
    source: r,
}); };
var symbols = __spreadArray(__spreadArray([], constants_1.singleCharacterSymbols, true), constants_1.multiCharacterSymbols, true);
var words = constants_1.reservedWords.map(escSpace);
var lex = (0, lex_1.wrapTokens)(words, symbols);
var lexScilla = function (s, removeComm) {
    if (removeComm === void 0) { removeComm = true; }
    console.time("wrapTokens");
    var lexed = lex(s);
    console.timeEnd("wrapTokens");
    if (removeComm) {
        return (0, parser_1.removeComments)(lexed);
    }
    return lexed;
};
exports.lexScilla = lexScilla;
//# sourceMappingURL=setup.js.map