"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildDeploy = void 0;
var shared_1 = require("./shared");
var getters_1 = require("./getters");
function buildDeploy(code, sourceCodeHash) {
    var init = (0, getters_1.getInitParamAST)().paramAST;
    var sig = init.map(function (i) { return i.varName + ": " + i.typescriptType; }).join(",\n");
    var initParams = init
        .map(function (i) { return (0, shared_1.getParam)(i.type, i.vname, i.varValue); })
        .join(",\n");
    var initParam = "[\n" + (0, shared_1.getParam)("Uint32", "_scilla_version", "\"" + (0, getters_1.getABI)().contract_info.scilla_major_version + "\"") + ",\n" + initParams + "\n]";
    return "deploy: (gasLimit: Long, " + sig + ") => {\n;\nconst transactionData = {\n  isDeploy: true,\n  ...sig,\n  data: " + initParam + ",\n}\nreturn {\n  /**\n   * get data needed to perform this transaction\n   * */\n  toJSON: () => transactionData,\n  /**\n   * send the transaction to the blockchain\n   * */\n  send: async () => dangerousFromJSONDeploy(txLink)(resolvers)(transactionData, gasLimit), \n    }\n}";
}
exports.buildDeploy = buildDeploy;
//# sourceMappingURL=deploy.js.map