"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getParam = exports.getParamAST = exports.removeComments = void 0;
var getTypescriptType_1 = require("./getTypescriptType");
function removeComments(code) {
    var start = -1;
    for (var i = 0; i < code.length - 1; i++) {
        var chars = code[i] + code[i + 1];
        if (chars == "(*") {
            start = i;
        }
        if (chars == "*)") {
            // const toRemove = code.substring(start, i+2)
            // console.log(toRemove)
            code = code.slice(0, start) + code.slice(i + 2, code.length);
            //start from the begining
            i = 0;
        }
    }
    return code;
}
exports.removeComments = removeComments;
var getVarValue = function (t, varRef, typescriptType) {
    if (typescriptType.startsWith("T.")) {
        return varRef + ".toSend()";
    }
    if (t.startsWith("BNum") ||
        t.startsWith("String") ||
        t.startsWith("ByStr") ||
        t.startsWith("Uint32") ||
        t.startsWith("Uint128") ||
        t.startsWith("Uint256")) {
        return varRef + ".toSend()";
    }
    if (t.startsWith("Uint")) {
        return varRef + ".toString()";
    }
    return varRef;
};
var getScillaSendType = function (t, contractName, contractAddressVarName) {
    //if is a custom adt replace all contractName. -> ${contractADdressVarName}.
    // . is important as it prevents replacing substrings of some definition
    if (t.includes(contractName) && !t.startsWith("ByStr20")) {
        if (contractAddressVarName.length == 0) {
            throw new Error("Couldn't bind as there are custom user ADTs in init parameters");
        }
        return t.replace(contractName + ".", "${(" + contractAddressVarName + ".toSend().toLowerCase())}.");
    }
    // scilla-checker returns the Bystr20 with contract field type as type but
    // this is not what deployment allows in the init params
    if (t.startsWith("ByStr20")) {
        return "ByStr20";
    }
    // ex:  type: `List (ByStr20 with contract field balances : Map (ByStr20) (Uint128) end)`
    // scilla stop griefing
    if (t.startsWith("List (ByStr20 with contract field")) {
        return "List (ByStr20)";
    }
    return t;
};
var getParamAST = function (a, abi, contractAddressVarName) {
    var contractName = abi.contract_info.vname;
    var statementsToAdd = [];
    var paramAST = a.map(function (i) {
        var varName = "__" + i.vname;
        var typescriptType = (0, getTypescriptType_1.getTypescriptType)(i.type, contractName, contractAddressVarName, abi, varName);
        statementsToAdd = statementsToAdd.concat.apply(statementsToAdd, typescriptType.statementsToAdd);
        return __assign(__assign({}, i), { varName: varName, typescriptType: typescriptType.typescriptType, varValue: getVarValue(i.type, varName, typescriptType.typescriptType), type: getScillaSendType(i.type, contractName, contractAddressVarName) });
    });
    return {
        statementsToAdd: statementsToAdd,
        paramAST: paramAST,
    };
};
exports.getParamAST = getParamAST;
var getParam = function (type, vname, value) { return "{\n    type: `" + type + "`,\n    vname: `" + vname + "`,\n    value: " + value + ",\n}"; };
exports.getParam = getParam;
//# sourceMappingURL=index.js.map