"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lexer = exports.customLex = exports.wrapTokens = void 0;
var keywords = ["transition", "procedure", "match", "end", "contract"];
var flow = new RegExp(/\s|\r|\n/g);
function labelWords(words) {
    return words.map(function (w) {
        if (keywords.includes(w)) {
            return { s: w, w: w };
        }
        return { s: "other", w: w };
    });
}
function wrapTokens(code, tokens) {
    tokens.sort(function (a, b) { return b.length - a.length; });
    var longestToken = tokens[0].length;
    var subIterate = longestToken - 1;
    for (var i = 0; i < code.length - subIterate; i++) {
        for (var _i = 0, tokens_1 = tokens; _i < tokens_1.length; _i++) {
            var token = tokens_1[_i];
            var start = i;
            var jump = token.length + 1;
            var end = i + token.length;
            var chars = code.substring(start, end);
            if (chars == token) {
                code =
                    code.slice(0, start) + (" " + token + " ") + code.slice(end, code.length);
                i = i + jump;
                break;
            }
        }
    }
    return code;
}
exports.wrapTokens = wrapTokens;
function customLex(code, tokens) {
    var words = wrapTokens(code, tokens)
        .split(flow)
        .filter(function (c) { return c != ""; });
    var labeled = labelWords(words);
    return labeled;
}
exports.customLex = customLex;
function lexer(code) {
    return customLex(code, [";", "(", "(", "(*", "*)", ":=", "=", "=>"]);
}
exports.lexer = lexer;
//# sourceMappingURL=zil-accept.js.map