"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.zilDoc = exports.getZilDocHeader = void 0;
function getZilDocHeader(contractName) {
    return "# I. " + contractName + " documentation\n\n";
}
exports.getZilDocHeader = getZilDocHeader;
function getTransitionArgumentsTable(t) {
    if (t.params.length == 0) {
        return "**No Arguments**\n\n";
    }
    return "  **Arguments:**\n\n|        | Name      | Type               |\n| ------ | --------- | ------------------ |\n" + t.params
        .map(function (p) { return "| @param | `" + p.vname + "` | `" + p.type + "`          |"; })
        .join("\n");
}
function zilDoc(t, lexed) {
    var reversed = __spreadArray([], lexed, true).reverse();
    var name = t.vname;
    var isBody = false;
    var comments = [];
    var index = 0;
    while (index < reversed.length) {
        var l = reversed[index];
        if (l.w == name && l.s == "other") {
            if (reversed[index + 1].s == "transition") {
                index++;
                break;
            }
        }
        index++;
    }
    for (var x = index; x < reversed.length; x++) {
        var l = reversed[x];
        if (l.w == "end" || l.w == "field") {
            break;
        }
        comments.push(l);
    }
    var commentsTextTmp = comments.map(function (c) { return c.w; }).reverse();
    commentsTextTmp.pop();
    var commentsText = commentsTextTmp
        .join(" ")
        .replace(/(\*\))|(\(\*)|(\*)/g, "")
        .replace(/\s+/g, " ");
    return "#### " + t.vname + "()\n\n" + commentsText + "\n\n" + getTransitionArgumentsTable(t);
}
exports.zilDoc = zilDoc;
//# sourceMappingURL=zil-doc.js.map