import { ByStr20 } from "./signable";
import "isomorphic-fetch";
import { Zilliqa } from "@zilliqa-js/zilliqa";
import { SDKResolvers } from ".";
export interface ContractSubStateQuery {
    [key: string]: "*" | ContractSubStateQuery | undefined;
}
export declare type ContractSubStateQueryCast<Keys extends string> = Partial<{
    [Key in Keys]: "*" | ContractSubStateQuery;
}>;
export declare const toAddrKey: (s: string) => string;
export declare type ReplaceStar<T> = {
    [P in keyof T]: T[P] extends "*" ? unknown : T[P] extends {} ? ReplaceStar<T[P]> : T[P];
};
declare type IsTrue<Condition, Result = {}> = Condition extends "true" ? Result & {
    _scilla_version: string;
    _creation_block: string;
    _this_address: string;
} : {};
/**
 * @param getZil resolver to a zilliqa object
 * @returns the state of the contracts
 * lower level method
 * using the boost-zil skds .state() is recommended instead
 */
export declare const partialState: (getZil: () => Promise<Zilliqa>) => <T extends ContractSubStateQuery, E extends "true" | "false", B extends {
    includeInit: E;
    contractAddress: ByStr20;
    query: T;
}, Init extends {}>(...partial: B[]) => Promise<({
    _this_address: ByStr20;
} & ReplaceStar<T> & {
    _init: IsTrue<E, Init>;
})[]>;
/**
 *
 * @param getZil from SDK resolvers
 * @returns a map by address of the different contracts state you asked for
 * the state map is indexed by address with ByStr20.toBech32()
 */
export declare const mappedPartialState: (getZil: SDKResolvers["getZil"]) => (...partial: {
    includeInit?: "true" | "false";
    contractAddress: ByStr20;
    includeBalance?: "true" | "false";
    query: ContractSubStateQuery;
}[]) => Promise<{
    [k: string]: Record<string, unknown>;
}>;
export {};
