"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mappedPartialState = exports.partialState = exports.toAddrKey = void 0;
var signable_1 = require("./signable");
require("isomorphic-fetch");
function addMeta(r) {
    return __assign(__assign({}, r), { id: "1", jsonrpc: "2.0" });
}
function sendBatchRPCMethodCalls(b, toUrl) {
    return __awaiter(this, void 0, void 0, function () {
        var response, text, result;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(toUrl, {
                        method: "POST",
                        headers: {
                            "Content-Type": "application/json",
                        },
                        body: JSON.stringify(b.map(addMeta)),
                    })];
                case 1:
                    response = _a.sent();
                    return [4 /*yield*/, response.text()];
                case 2:
                    text = _a.sent();
                    result = JSON.parse(text);
                    return [2 /*return*/, result];
            }
        });
    });
}
function assignKeys(target, keys, value) {
    var tmp = target;
    var lastKey = keys[keys.length - 1];
    for (var index = 0; index < keys.length - 1; index++) {
        var k = keys[index];
        if (typeof tmp[k] == "undefined") {
            tmp[k] = {};
        }
        tmp = tmp[k];
    }
    tmp[lastKey] = value;
}
function callToValue(call, keys) {
    var result = call.result;
    if (typeof result == "undefined" || result == null) {
        // console.warn(
        //   "Call result for key trail:",
        //   keys,
        //   "is undefined, this might not be defined in the smart contract!"
        // );
        return undefined;
    }
    var tmp = result;
    keys.forEach(function (k) { return (tmp = tmp[k]); });
    return tmp;
}
function restoreObject(res, b) {
    if (b.includeInit == "true") {
        var initResult_1 = { original: res[0].result };
        // surgically update the init state to something comprehensible
        res[0].result.forEach(function (r) { return (initResult_1[r.vname] = r.value); });
        res[0].result = initResult_1;
    }
    var resultObject = {};
    for (var index in res) {
        var call = res[index];
        var meta = b.meta[index];
        assignKeys(resultObject, meta.putFields, callToValue(call, meta.responseFields));
    }
    return resultObject;
}
function passQuery(q, fields, queries, contractAddress) {
    var entries = Object.entries(q);
    if (entries.length == 0) {
        return queries;
    }
    var res = [];
    for (var _i = 0, entries_1 = entries; _i < entries_1.length; _i++) {
        var _a = entries_1[_i], field = _a[0], starOrFields = _a[1];
        if (!starOrFields)
            throw new Error("Pass query: starOrFields undefined");
        if (starOrFields == "*") {
            var allFields = fields.concat(field);
            var firstField = allFields.shift();
            if (!firstField)
                throw new Error("Pass query: firstField undefined");
            res.push({
                query: { params: [contractAddress, firstField, allFields] },
                meta: { fields: __spreadArray([firstField], allFields, true) },
            });
        }
        else {
            res.push.apply(res, passQuery(starOrFields, __spreadArray(__spreadArray([], fields, true), [field], false), [], contractAddress));
        }
    }
    return res;
}
function partialQueryToRPC(partial) {
    var includeInit = partial.includeInit, includeBalance = partial.includeBalance;
    var balance = includeBalance == "true"
        ? [
            addMeta({
                method: "GetBalance",
                params: [partial.contractAddress.noPrefixed()],
            }),
        ]
        : [];
    var init = includeInit == "true"
        ? [
            addMeta({
                method: "GetSmartContractInit",
                params: [partial.contractAddress.noPrefixed()],
            }),
        ]
        : [];
    var initMeta = includeInit == "true" ? [{ responseFields: [], putFields: ["_init"] }] : [];
    var balanceMeta = includeBalance == "true"
        ? [{ responseFields: ["balance"], putFields: ["_balance"] }]
        : [];
    var subStateQueries = passQuery(partial.query, [], [], partial.contractAddress.noPrefixed());
    var queries = __spreadArray(__spreadArray(__spreadArray([], balance, true), init, true), subStateQueries
        .map(function (r) { return r.query; })
        .map(function (r) { return addMeta(__assign(__assign({}, r), { method: "GetSmartContractSubState" })); }), true);
    var meta = __spreadArray(__spreadArray(__spreadArray([], balanceMeta, true), initMeta, true), subStateQueries.map(function (r) { return ({
        responseFields: r.meta.fields,
        putFields: r.meta.fields,
    }); }), true);
    return { queries: queries, meta: meta, includeInit: includeInit };
}
var toAddrKey = function (s) { return new signable_1.ByStr20(s).lowerCase(); };
exports.toAddrKey = toAddrKey;
function cutArray(arr, cuts) {
    var res = [];
    var start = 0;
    for (var _i = 0, cuts_1 = cuts; _i < cuts_1.length; _i++) {
        var cut = cuts_1[_i];
        res.push(arr.slice(start, cut + start));
        start += cut;
    }
    return res;
}
/**
 * @param getZil resolver to a zilliqa object
 * @returns the state of the contracts
 * lower level method
 * using the boost-zil skds .state() is recommended instead
 */
var partialState = function (getZil) {
    return function () {
        var partial = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            partial[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var partialQueryToRpcRes, zil, node, result, cut, restored;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        partialQueryToRpcRes = partial.map(function (o) {
                            var r = partialQueryToRPC(o);
                            return {
                                length: r.queries.length,
                                toRpc: r,
                            };
                        });
                        return [4 /*yield*/, getZil()];
                    case 1:
                        zil = _a.sent();
                        node = zil;
                        return [4 /*yield*/, sendBatchRPCMethodCalls(partialQueryToRpcRes.map(function (p) { return p.toRpc.queries; }).flat(), node.provider.nodeURL)];
                    case 2:
                        result = _a.sent();
                        cut = cutArray(result, partialQueryToRpcRes.map(function (o) { return o.length; }));
                        restored = cut.map(function (res, index) { return (__assign({ _this_address: partial[index].contractAddress }, restoreObject(res, partialQueryToRpcRes[index].toRpc))); });
                        return [2 /*return*/, restored];
                }
            });
        });
    };
};
exports.partialState = partialState;
/**
 *
 * @param getZil from SDK resolvers
 * @returns a map by address of the different contracts state you asked for
 * the state map is indexed by address with ByStr20.toBech32()
 */
var mappedPartialState = function (getZil) {
    return function () {
        var partial = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            partial[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var partialQueryToRpcRes, zil, node, result, cut, restored;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        partialQueryToRpcRes = partial.map(function (o) {
                            var r = partialQueryToRPC(__assign(__assign({}, o), { includeInit: o.includeInit ? o.includeInit : "false" }));
                            return {
                                length: r.queries.length,
                                toRpc: r,
                            };
                        });
                        return [4 /*yield*/, getZil()];
                    case 1:
                        zil = (_a.sent()).zil;
                        node = zil;
                        return [4 /*yield*/, sendBatchRPCMethodCalls(partialQueryToRpcRes.map(function (p) { return p.toRpc.queries; }).flat(), node.provider.nodeURL)];
                    case 2:
                        result = _a.sent();
                        cut = cutArray(result, partialQueryToRpcRes.map(function (o) { return o.length; }));
                        restored = cut.map(function (res, index) { return (__assign({ _this_address: partial[index].contractAddress }, restoreObject(res, partialQueryToRpcRes[index].toRpc))); });
                        return [2 /*return*/, restored.reduce(function (prev, cur) {
                                prev[cur._this_address.toBech32()] = cur;
                                return prev;
                            }, {})];
                }
            });
        });
    };
};
exports.mappedPartialState = mappedPartialState;
//# sourceMappingURL=partialState.js.map