#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("./shared");
var shared_2 = require("../binder/shared");
var path_1 = require("path");
var slotMachineScilla_1 = __importDefault(require("./slotMachineScilla"));
var testSlotMachine_1 = __importDefault(require("./testSlotMachine"));
function main() {
    return __awaiter(this, void 0, void 0, function () {
        var src, scillaFile, testSrc, testFile, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 11, , 12]);
                    return [4 /*yield*/, (0, shared_1.createPackage)()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.createGitignore)()];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.installDevDependencies)()];
                case 3:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.createSrc)()];
                case 4:
                    src = _a.sent();
                    scillaFile = src + "/SmartContract.scilla";
                    return [4 /*yield*/, (0, shared_1.createFile)(slotMachineScilla_1.default, (0, path_1.resolve)(process.cwd(), scillaFile), true)];
                case 5:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.createTest)()];
                case 6:
                    testSrc = _a.sent();
                    testFile = testSrc + "/smart-contract.test.ts";
                    return [4 /*yield*/, (0, shared_1.createFile)(testSlotMachine_1.default, (0, path_1.resolve)(process.cwd(), testFile), true)];
                case 7:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.createBoostZilFile)(scillaFile)];
                case 8:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.installBoostZil)()];
                case 9:
                    _a.sent();
                    return [4 /*yield*/, (0, shared_1.tscInit)()];
                case 10:
                    _a.sent();
                    return [3 /*break*/, 12];
                case 11:
                    e_1 = _a.sent();
                    console.error(shared_2.RED, e_1);
                    return [3 /*break*/, 12];
                case 12: return [2 /*return*/];
            }
        });
    });
}
if (require.main === module) {
    main();
}
//# sourceMappingURL=init-project.js.map