"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPackage = exports.createTest = exports.createSrc = exports.installDevDependencies = exports.installBoostZil = exports.tscInit = exports.promisifiedExec = exports.createGitignore = exports.createBoostZilFile = exports.createFile = void 0;
var shared_1 = require("../binder/shared");
var path_1 = require("path");
var fs_1 = require("fs");
var child_process_1 = require("child_process");
function createFile(payload, relPath, isAbsolutePath) {
    return __awaiter(this, void 0, void 0, function () {
        var rootDir, filePath, name;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, (0, shared_1.getPkgJsonDir)()];
                case 1:
                    rootDir = _a.sent();
                    filePath = isAbsolutePath ? relPath : (0, path_1.resolve)(rootDir, relPath);
                    name = filePath.split("/").shift();
                    if (!(0, fs_1.existsSync)(filePath)) {
                        (0, fs_1.writeFileSync)(filePath, payload);
                        console.log(shared_1.GREEN, "\uD83D\uDCD6 created " + name + " at " + filePath);
                    }
                    else {
                        console.log(name + " already exists.");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.createFile = createFile;
function createBoostZilFile() {
    var contracts = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        contracts[_i] = arguments[_i];
    }
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("🚀 creating boost-zil.json");
                    return [4 /*yield*/, createFile(JSON.stringify({
                            contracts: contracts,
                            makeSigners: false,
                        }, null, 2), (0, path_1.resolve)(process.cwd(), "./boost-zil.json"), true)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.createBoostZilFile = createBoostZilFile;
function createGitignore() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("✨ creating .gitignore");
                    return [4 /*yield*/, createFile("node_modules\n.env", (0, path_1.resolve)(process.cwd(), "./.gitignore"), true)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.createGitignore = createGitignore;
function promisifiedExec(toExec) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                        (0, child_process_1.exec)(toExec, function (err, stdout, stderr) {
                            if (err) {
                                reject(err);
                            }
                            if (stderr != "" && typeof stderr != "undefined") {
                                console.log(shared_1.MAGENTA, stderr);
                            }
                            resolve(stdout);
                        });
                    })];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports.promisifiedExec = promisifiedExec;
function tscInit() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("👨‍💻 initializing typescript");
                    return [4 /*yield*/, promisifiedExec("npx tsc --init")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.tscInit = tscInit;
function installBoostZil() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("🔥 installing boost-zil");
                    return [4 /*yield*/, promisifiedExec("npm i --save boost-zil")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.installBoostZil = installBoostZil;
function installDevDependencies() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("🛠️  installing dev dependencies");
                    return [4 /*yield*/, promisifiedExec("npm i -D @types/big.js @types/bn.js @types/chai @types/create-hash @types/long @types/mocha @types/node chai mocha ts-node tslib typescript")];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.installDevDependencies = installDevDependencies;
function createSrc() {
    return __awaiter(this, void 0, void 0, function () {
        var src;
        return __generator(this, function (_a) {
            src = "./src/SmartContract";
            (0, fs_1.mkdirSync)((0, path_1.resolve)(process.cwd(), src), { recursive: true });
            return [2 /*return*/, src];
        });
    });
}
exports.createSrc = createSrc;
function createTest() {
    return __awaiter(this, void 0, void 0, function () {
        var src;
        return __generator(this, function (_a) {
            src = "./test";
            (0, fs_1.mkdirSync)((0, path_1.resolve)(process.cwd(), src), { recursive: true });
            return [2 /*return*/, src];
        });
    });
}
exports.createTest = createTest;
function createPackage() {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("📦 creating package.json");
                    return [4 /*yield*/, createFile(JSON.stringify({
                            scripts: {
                                build: "boost-zil-build",
                                test: "npm run build && mocha -r ts-node/register 'test/**/*test.ts' --timeout 1000000",
                            },
                            dependencies: {},
                            devDependencies: {},
                        }, null, 2), (0, path_1.resolve)(process.cwd(), "./package.json"), true)];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    });
}
exports.createPackage = createPackage;
//# sourceMappingURL=shared.js.map