"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomADT = void 0;
var shared_1 = require("./shared");
var utill_1 = require("../utill");
/**
 * {
    tname: string;
    tparams: string[];
    tmap: {
        cname: string;
        argtypes: string[];
    }[];
    {
        constructor: `${addr}.Uint128Pair`,
        argtypes: [],
        arguments: [threshold.toString(), discount.toString()],
    }
}
 */
var CustomADT = /** @class */ (function (_super) {
    __extends(CustomADT, _super);
    function CustomADT() {
        var v = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            v[_i] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.value = v;
        return _this;
    }
    CustomADT.prototype.toHash = function () {
        return utill_1.getHashed.apply(void 0, this.value).chequeHash;
    };
    CustomADT.prototype.toSend = function () {
        return {
            constructor: this.getType(),
            argtypes: [],
            arguments: this.value.map(function (v) { return v.toSend(); }),
        };
    };
    CustomADT.prototype.setADTname = function (s) {
        this.type = s;
        this.ADTname = s;
        this.value.forEach(function (v) { return v.setADTname(s); });
        return this;
    };
    CustomADT.prototype.setContractAddress = function (a) {
        this.contractAddress = a;
        this.value.forEach(function (v) { return v.setContractAddress(a); });
        return this;
    };
    CustomADT.prototype.getType = function () {
        if (!this.contractAddress) {
            throw new Error("Contract name not set!");
        }
        if (!this.ADTname) {
            throw new Error("Custom ADT name not set!");
        }
        return this.contractAddress.toSend().toLowerCase() + "." + this.ADTname;
    };
    return CustomADT;
}(shared_1.Signable));
exports.CustomADT = CustomADT;
//# sourceMappingURL=customADT.js.map