"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sha256 = exports.Signable = void 0;
var create_hash_1 = __importDefault(require("create-hash"));
var Signable = /** @class */ (function () {
    function Signable() {
    }
    Signable.prototype.setContractAddress = function (contractAddress) {
        this.contractAddress = contractAddress;
        return this;
    };
    Signable.prototype.setADTname = function (ADTname) {
        this.ADTname = ADTname;
        return this;
    };
    Signable.prototype.getType = function () {
        if (!this.type) {
            throw new Error("type was not defined!");
        }
        return this.type;
    };
    return Signable;
}());
exports.Signable = Signable;
/**
 * @param b
 * @returns hash of form `0x${sha.digest().toString("hex")}`
 */
function sha256(b) {
    var sha = (0, create_hash_1.default)("sha256");
    sha.update(Buffer.from(b, "hex"));
    return "0x" + sha.digest().toString("hex");
}
exports.sha256 = sha256;
//# sourceMappingURL=shared.js.map