"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFundedAccount = exports.getResolversFromAccount = exports.isolatedServer = exports.sleep = void 0;
var child_process_1 = require("child_process");
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
var account_1 = require("@zilliqa-js/account");
var zilliqa_1 = require("@zilliqa-js/zilliqa");
var signable_1 = require("../signable");
var sleep = function (milis) {
    return new Promise(function (res) { return setTimeout(res, milis); });
};
exports.sleep = sleep;
var exe = function (command) {
    return new Promise(function (res, rej) {
        (0, child_process_1.exec)(command, function (error, stdout, stderr) {
            if (error)
                rej(error);
            res(stdout);
        });
    });
};
var serverPath = path_1.default.resolve(__dirname, "./tmp_server");
/**
 * isolated server object
 * has all of the config to do testing, including a funded private key
 * make sure to .kill() the server after you are done
 */
exports.isolatedServer = {
    mockConfig: {
        networkname: "isolated",
        version: "14548995",
        nodeurl: "http://localhost:5555",
    },
    submitterPrivateKey: "e53d1c3edaffc7a7bab5418eb836cf75819a82872b4a1a0f1c7fcf5c3e020b89",
    otherKeys: {
        second: {
            bystr20: "0x6cd3667ba79310837e33f0aecbe13688a6cbca32",
            privateKey: "b87f4ba7dcd6e60f2cca8352c89904e3993c5b2b0b608d255002edcda6374de4",
        },
    },
    start: function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!!fs_1.default.existsSync(serverPath)) return [3 /*break*/, 2];
                    console.log("Downloading isolated server ...");
                    return [4 /*yield*/, exe("git clone https://github.com/Zilliqa/zilliqa-isolated-server.git " + serverPath)];
                case 1:
                    _a.sent();
                    _a.label = 2;
                case 2:
                    console.log("Building isolated server ...");
                    return [4 /*yield*/, exe("cd " + serverPath + " && docker build --rm -f \"Dockerfile\" -t isolatedserver:1 \".\" -t tmp_server")];
                case 3:
                    _a.sent();
                    console.log("Running isolated server ...");
                    return [4 /*yield*/, exe("docker run -d -p 5555:5555 -t tmp_server")];
                case 4:
                    _a.sent();
                    console.log("Waiting 3 sec for the isolated server to set up");
                    return [4 /*yield*/, (0, exports.sleep)(3000)];
                case 5:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); },
    kill: function () { return __awaiter(void 0, void 0, void 0, function () {
        var container;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    console.log("Killing the last created docker container ...");
                    return [4 /*yield*/, exe("docker ps -lq")];
                case 1:
                    container = (_a.sent()).trim();
                    return [4 /*yield*/, exe("docker kill " + container)];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, exe("docker rm " + container)];
                case 3:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); },
};
/**
 * isolated server resolvers from account
 */
function getResolversFromAccount(a) {
    var _this = this;
    var c = exports.isolatedServer.mockConfig;
    var version = c.version;
    var resolvers = {
        getZil: function (signer) { return __awaiter(_this, void 0, void 0, function () {
            var teardown, zil;
            var _this = this;
            return __generator(this, function (_a) {
                teardown = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/];
                }); }); };
                zil = new zilliqa_1.Zilliqa(c.nodeurl);
                if (signer) {
                    zil.wallet.addByPrivateKey(a.privateKey);
                    teardown = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                        return [2 /*return*/];
                    }); }); };
                }
                return [2 /*return*/, { zil: zil, teardown: teardown }];
            });
        }); },
        getVersion: function () { return parseInt(version); },
        getNetworkName: function () { return c.networkname; },
    };
    return resolvers;
}
exports.getResolversFromAccount = getResolversFromAccount;
/**
 *
 * @returns a funded account on the isolated server
 */
function getFundedAccount() {
    var adminAcc = new account_1.Account(exports.isolatedServer.submitterPrivateKey);
    var adminAddr = new signable_1.ByStr20(adminAcc.address);
    var adminPubKey = new signable_1.ByStr33(adminAcc.publicKey);
    return { adminAcc: adminAcc, adminAddr: adminAddr, adminPubKey: adminPubKey };
}
exports.getFundedAccount = getFundedAccount;
//# sourceMappingURL=index.js.map