"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMainnetResolvers = exports.signTransition = exports.signWithContractAddress = exports.getHashed = exports.concatHashed = exports.verifySignature = exports.signWithAccount = exports.normaliseAddress = void 0;
var schnorr = __importStar(require("./schnorr"));
var bystr_1 = require("./signable/bystr");
var signable_1 = require("./signable");
var zilliqa_1 = require("@zilliqa-js/zilliqa");
var util_1 = require("@zilliqa-js/util");
var normaliseAddress = function (address) {
    if (util_1.validation.isBech32(address)) {
        return (0, zilliqa_1.fromBech32Address)(address);
    }
    if (!util_1.validation.isAddress(address.replace("0x", ""))) {
        throw Error("Wrong address format, should be either bech32 or checksummed address");
    }
    return (0, zilliqa_1.toChecksumAddress)(address);
};
exports.normaliseAddress = normaliseAddress;
/**
 * sign
 *
 * @param {string} hash - hex-encoded hash of the data to be signed
 *
 * @returns {string} the signature
 */
var sign = function (msg, privateKey, pubKey) {
    var sig = schnorr.sign(msg, Buffer.from(privateKey, "hex"), Buffer.from(pubKey, "hex"));
    var r = sig.r.toString("hex");
    var s = sig.s.toString("hex");
    while (r.length < 64) {
        r = "0" + r;
    }
    while (s.length < 64) {
        s = "0" + s;
    }
    return r + s;
};
function signWithAccount(cheque_hash, acc) {
    return new bystr_1.ByStr64("0x" + sign(Buffer.from(cheque_hash.replace("0x", ""), "hex"), acc.privateKey, acc.publicKey));
}
exports.signWithAccount = signWithAccount;
/**
 *
 * @param cheque_hash starts with 0x or not
 * @param signature starts with 0x or not
 * @param pubkey starts with 0x or not
 * @returns if valid
 */
function verifySignature(cheque_hash, signature, pubkey) {
    return schnorr.verify(Buffer.from(cheque_hash.replace("0x", ""), "hex"), schnorr.toSignature(signature.replace("0x", "")), Buffer.from(pubkey.replace("0x", ""), "hex"));
}
exports.verifySignature = verifySignature;
function concatHashed() {
    var hashes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        hashes[_i] = arguments[_i];
    }
    return "0x" + hashes.reduce(function (prev, cur) { return prev + cur.replace("0x", ""); }, "");
}
exports.concatHashed = concatHashed;
function getHashed() {
    var hashes = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        hashes[_i] = arguments[_i];
    }
    return {
        args: hashes,
        chequeHash: concatHashed.apply(void 0, hashes.map(function (a) { return a.toHash(); })),
    };
}
exports.getHashed = getHashed;
/**
 * @dev signs the args in order like in the contracts implementation
 * appending the contract address | _this_address at the end of the sig payload
 */
var signWithContractAddress = function (addr) {
    return function (acc) {
        return function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var res = getHashed.apply(void 0, __spreadArray(__spreadArray([], args, false), [addr], false));
            var signature = signWithAccount(res.chequeHash, acc);
            return __spreadArray(__spreadArray([], args, true), [signature], false);
        };
    };
};
exports.signWithContractAddress = signWithContractAddress;
/**
 * @dev signs the args in order like in the contracts implementation
 * appending the nonce transition name _this_address at the end of the sig payload
 */
var signTransition = function (addr) {
    return function (name) {
        return function (acc) {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var nonce = signable_1.Uint128.getRandom();
                var chequeHash = getHashed.apply(void 0, __spreadArray(__spreadArray([], args, false), [nonce,
                    new signable_1.ScillaString(name),
                    addr], false)).chequeHash;
                var signature = signWithAccount(chequeHash, acc);
                return {
                    args: __spreadArray(__spreadArray([], args, true), [nonce, signature], false),
                    chequeHash: chequeHash,
                };
            };
        };
    };
};
exports.signTransition = signTransition;
/**
 * returns resolvers to mainnet
 * @param a optional zilliqa account
 * @returns
 */
function getMainnetResolvers(a) {
    var _this = this;
    var c = {
        nodeurl: "https://api.zilliqa.com/",
        version: "65537",
        networkname: "mainnet",
    };
    var getZil = a
        ? function (signer) { return __awaiter(_this, void 0, void 0, function () {
            var teardown, zil;
            var _this = this;
            return __generator(this, function (_a) {
                teardown = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/];
                }); }); };
                zil = new zilliqa_1.Zilliqa(c.nodeurl);
                if (signer) {
                    zil.wallet.addByPrivateKey(a.privateKey);
                    teardown = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                        return [2 /*return*/];
                    }); }); };
                }
                return [2 /*return*/, { zil: zil, teardown: teardown }];
            });
        }); }
        : function () { return __awaiter(_this, void 0, void 0, function () {
            var teardown, zil;
            var _this = this;
            return __generator(this, function (_a) {
                teardown = function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
                    return [2 /*return*/];
                }); }); };
                zil = new zilliqa_1.Zilliqa(c.nodeurl);
                return [2 /*return*/, { zil: zil, teardown: teardown }];
            });
        }); };
    var resolvers = {
        getZil: getZil,
        getVersion: function () { return parseInt(c.version); },
        getNetworkName: function () { return c.networkname; },
    };
    return resolvers;
}
exports.getMainnetResolvers = getMainnetResolvers;
//# sourceMappingURL=utill.js.map