export declare const boilerplate = "\n\ndeclare var window: any\n\nexport type TXLog = (t: Transaction, msg: string) => void;\n\nconst thereIsZilPay = () => {\n  if (typeof window != \"undefined\") {\n    if (typeof window.zilPay != \"undefined\") {\n      return true;\n    }\n  }\n  return false;\n};\n\nconst getTrail = () => {\n  if (thereIsZilPay()) {\n    return []\n  } else {\n    return [31, 1000]\n  }\n}\n\n/**\n * will try to send a transaction to the contract\n * @warning WILL NOT THROW ERRORS IF CONTRACT SIGNATURES ARE INVALID\n */\nconst dangerousFromJSONDeploy =\n  (txLink: TXLog) =>\n  ({ getVersion, getZil }: SDKResolvers) =>\n  async (t: Omit<Omit<DeployData, \"isDeploy\">, \"code\">, gasLimit: Long) => {\n    let teardownFun: any;\n    try {\n    const { zil, teardown } = await getZil(true);\n    teardownFun = teardown;\n    const gasPrice = await getMinGasPrice(zil);\n\n    const contract = newContract(zil, code, t.data);\n    const [tx, con] = await contract.deploy(\n      {\n        version: getVersion(),\n        gasPrice,\n        gasLimit,\n      },\n      ...getTrail()\n    );\n    await teardown();\n    txLink(tx, \"Deploy\");\n    if (!con.address) {\n      if (con.error) {\n        throw new Error(JSON.stringify(con.error, null, 2));\n      }\n      throw new Error(\"Contract failed to deploy\");\n    }\n    return { tx, contract: con, address: new T.ByStr20(con.address) };\n  } catch(e) {\n    if (teardownFun) {\n      await teardownFun();\n    }\n    throw e;\n  }\n  throw \"this never happens leave me alone ts\"\n  };\n\n/**\n * will try to send a transaction to the contract\n * @warning WILL NOT THROW ERRORS IF CONTRACT SIGNATURES ARE INVALID\n */\nconst dangerousFromJSONCall =\n  (txLink: TXLog) =>\n  ({ getVersion, getZil }: SDKResolvers) =>\n  async (t: Omit<CallData, \"isDeploy\">, gasLimit: Long) => {\n    let teardownFun: any;\n    try {\n    const { zil, teardown } = await getZil(true);\n    teardownFun = teardown;\n    const gasPrice = await getMinGasPrice(zil);\n    const contract = getContract(\n      zil,\n      new T.ByStr20(t.contractAddress).toSend()\n    );\n\n    const tx = await contract.call(\n      t.contractTransitionName,\n      t.data,\n      {\n        version: getVersion(),\n        amount: new BN(t.amount),\n        gasPrice,\n        gasLimit,\n      },\n      ...getTrail()\n    );\n    await teardown();\n    txLink(tx, t.contractTransitionName);\n    return { tx };\n    } catch(e) {\n      if(teardownFun){\n        await teardownFun();\n      }\n      throw e;\n    }\n    throw \"this never happens leave me alone ts\"\n  };\n\n\nexport interface SDKResolvers {\n  getZil: (\n    requireSigner?: boolean\n  ) => Promise<{ zil: Zilliqa; teardown: () => Promise<void> }>;\n  getVersion: () => number;\n  getNetworkName: () => string;\n  txLog?: TXLog;\n}\n\n\nconst RED = \"\\x1B[31m%s\\x1b[0m\";\nconst CYAN = \"\\x1B[36m%s\\x1b[0m\";\nconst GREEN = \"\\x1B[32m%s\\x1b[0m\";\nconst MAGENTA = \"\\x1B[35m%s\\x1b[0m\";\n\ninterface Value {\n  vname: string;\n  type: string;\n  value: string | ADTValue | ADTValue[] | string[];\n}\ninterface ADTValue {\n  constructor: string;\n  argtypes: string[];\n  arguments: Value[] | string[];\n}\n\ninterface DeployData {\n  isDeploy: boolean;\n  /**\n   * the signature hash of the source code of the contract that this data interacts with\n   */\n  contractSignature: string;\n  /**\n   * code of the contract to deploy\n   */\n  code: string;\n  data: any[];\n}\ninterface CallData {\n  isDeploy: boolean;\n  /**\n   * the signature hash of the source code of the contract that this data interacts with\n   */\n  contractSignature: string;\n  /**\n   * contract to send the transaction to\n   */\n  contractAddress: string;\n  /**\n   * zil amount to send\n   */\n  amount: string;\n  /**\n   * the name of the transition called in the target contract\n   */\n  contractTransitionName: string;\n  data: any[];\n}\n/**\n * general interface of the data returned by toJSON() on the transitions\n */\ntype TransactionData = DeployData | CallData;\n\nfunction getContract(\n  zil: Zilliqa,\n  a: string\n): Contract & {\n  call: (\n    transition: string,\n    args: Value[],\n    params: Pick<\n      TxParams,\n      \"version\" | \"amount\" | \"gasPrice\" | \"gasLimit\" | \"nonce\" | \"pubKey\"\n    >,\n    attempts?: number,\n    interval?: number,\n    toDs?: boolean\n  ) => ReturnType<Contract[\"call\"]>;\n} {\n  const address = new T.ByStr20(a).toSend();\n  //@ts-ignore\n  return zil.contracts.at(address);\n}\n\nfunction newContract(zil: Zilliqa, code: string, init: Value[]): Contract {\n  //@ts-ignore\n  return zil.contracts.new(code, init);\n}\n\nasync function getMinGasPrice(zil: Zilliqa) {\n  const res = await zil.blockchain.getMinimumGasPrice();\n  if (!res.result) {\n    throw \"no gas price\";\n  }\n  return new BN(res.result);\n}\n";
