declare const _default: "import {\n    ByStr20,\n    ByStr33,\n    createAccount,\n    Uint128,\n    SDKResolvers,\n} from \"boost-zil\";\nimport { Account } from \"@zilliqa-js/account\";\nimport { isolatedServer, getResolversFromAccount } from \"boost-zil/lib/testing\";\nimport { SlotMachine } from \"../src/SmartContract/build/bind\";\nimport { Long } from \"@zilliqa-js/zilliqa\";\n\nlet admin: ByStr20;\nlet adminPubKey: ByStr33;\nlet adminAcc: Account;\nlet slotMachine: ReturnType<typeof SlotMachine>;\nlet fundingAccount: ReturnType<typeof createAccount>;\nlet resolvers: SDKResolvers;\n\nconst limit = Long.fromString(\"60000\");\n\ndescribe(\"on blockchain\", async () => {\n    before(async () => {\n        await isolatedServer.start();\n        adminAcc = new Account(isolatedServer.submitterPrivateKey);\n        admin = new ByStr20(adminAcc.address);\n        adminPubKey = new ByStr33(adminAcc.publicKey);\n        resolvers = getResolversFromAccount(adminAcc);\n        fundingAccount = createAccount();\n    });\n    after(async () => {\n        await isolatedServer.kill();\n    });\n    it(\"contract works\", async () => {\n        const ticketPrice = Uint128.zil(\"10\");\n        const vault = createAccount();\n        const { address: slotMachineAddr } = await slotMachine\n        .deploy(\n            limit,\n            adminPubKey,\n            vault.address,\n            ticketPrice,\n            // 30% cut\n            new Uint128(\"3000\")\n        )\n        .send();\n\n        const callMachine = slotMachine.calls(slotMachineAddr)(limit);\n\n        // FUND AS ADMIN\n        await callMachine.AddFunds(Uint128.zil(\"1000\")).send();\n\n        // TODO: do more tests\n    });\n});\n";
export default _default;
